package de.hft.stuttgart.citydoctor2.healer.genetic;

import static org.junit.Assert.*;

import org.junit.Test;

import de.hft.stuttgart.citydoctor2.healer.HealingMethods;
import de.hft.stuttgart.citydoctor2.healer.HealingPlan;

public class GeneticAlgorithmTest {

	@Test
	public void test() {
		Crossover<HealingPlan> cross = new OrderCrossover();
		Mutation<HealingPlan> mutation = new NoMutation();
		FitnessEvaluation<HealingPlan> fitness = new RandomFitness();
		Heuristic<HealingPlan> heuristic = new RandomHeuristic(HealingMethods.getAvailableHealingMethods());
		GeneticAlgorithm<HealingPlan> ga = GeneticAlgorithm.of(cross, mutation, heuristic, fitness);
		ga.run();
		assertNotNull(ga.getResult());
	}

}
