package de.hft.stuttgart.citydoctor2.webservice.utils;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

public class HibernateUtils {
	
	private HibernateUtils() {
		// only static use
	}
	
	private static EntityManagerFactory factory;
	
	public static void init() {
		if (factory == null) {
			factory = Persistence.createEntityManagerFactory("CDPersistence");
		}
	}
	
	public static EntityManager createManager() {
		init();
		return factory.createEntityManager();
	}
	
	public static void shutdown() {
		if (factory != null) {
			factory.close();
		}
	}
	
	public static void closeManager(EntityManager manager) {
		if (manager != null) {
			manager.close();
		}
	}

}
