package de.hft.stuttgart.citydoctor2.ziploader.gui;

import de.hft.stuttgart.citydoctor2.check.Checker;
import de.hft.stuttgart.citydoctor2.datastructure.CityDoctorModel;
import de.hft.stuttgart.citydoctor2.gui.MainWindow;
import de.hft.stuttgart.citydoctor2.gui.View;
import javafx.fxml.FXMLLoader;
import javafx.scene.Node;
import javafx.scene.image.Image;
import javafx.scene.layout.HBox;
import javafx.stage.FileChooser;
import javafx.stage.Window;

import java.io.File;
import java.io.IOException;
import java.util.Optional;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class ZipLoaderView extends View{

    private static final Logger logger = LogManager.getLogger(ZipLoaderView.class);

    Image image;
    private Window parent;
    private Node zipLoaderWindow;
    private ZipLoaderController controller;
    private ZipLoaderToolbar toolbar;



    public ZipLoaderView() {
        image = new Image(getClass().getResourceAsStream("zip.png"));
    }

    @Override
    public Optional<HBox> getToolbar() {
        return Optional.empty();
    }

    @Override
    public Node getMainScreen() {
        return null;
    }

    @Override
    public Image getViewLogo() {
        return image;
    }

    @Override
    public void initializeView(MainWindow mainWindow) {
        this.parent = mainWindow.getMainStage();
        FXMLLoader loader = new FXMLLoader(getClass().getResource("ZipLoaderGUI.fxml"));
        loader.setController(this);
        try {
            zipLoaderWindow = loader.load();
            controller = new ZipLoaderController(this);
            toolbar = new ZipLoaderToolbar(controller, mainWindow);
        } catch (IOException e) {
            logger.catching(e);
        }

    }

    @Override
    public void onHide() {

    }

    @Override
    public void onShow(CityDoctorModel model, Checker checker) {

    }

    private void openZipArchive(){
        FileChooser fileChooser = new FileChooser();
        fileChooser.setTitle("Open ZIP-file");
        fileChooser.getExtensionFilters().add(
                new FileChooser.ExtensionFilter("Zip File", "*.zip"));
        File selectedFile = fileChooser.showOpenDialog(parent);
        if(selectedFile != null){
            controller.openZipArchive(selectedFile);
        }
    }
}
